package meta_programming;

import java.lang.reflect.Method;

public class Sample25 {

	public static void main(String[] args) throws Exception {
		for (int i = 0; i < 3; i++) {
			normal();
			reflect();

			System.out.println("---");
		}
	}

	private static void normal() {
		Sample25 sample25 = new Sample25();
		long start = System.nanoTime();
		for (int i = 0; i < 100000; i++) {
			sample25.toString();
		}
		long end = System.nanoTime();
		System.out.println(end - start);
	}

	private static void reflect() throws Exception {
		Sample25 sample25 = new Sample25();
		Method method = Sample25.class.getMethod("toString");
		long start = System.nanoTime();
		for (int i = 0; i < 100000; i++) {
			method.invoke(sample25);
		}
		long end = System.nanoTime();
		System.out.println(end - start);
	}

	@Override
	public String toString() {
		return null;
	}
}